/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// TxDestination A list of recipients.
type TxDestination struct {
	// The destination address.
	Destination string `json:"destination"`
	// The amount you wish to transfer.
	Amount string `json:"amount"`
}

// NewTxDestination instantiates a new TxDestination object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTxDestination(destination string, amount string) *TxDestination {
	this := TxDestination{}
	this.Destination = destination
	this.Amount = amount
	return &this
}

// NewTxDestinationWithDefaults instantiates a new TxDestination object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTxDestinationWithDefaults() *TxDestination {
	this := TxDestination{}
	return &this
}

// GetDestination returns the Destination field value
func (o *TxDestination) GetDestination() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Destination
}

// GetDestinationOk returns a tuple with the Destination field value
// and a boolean to check if the value has been set.
func (o *TxDestination) GetDestinationOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Destination, true
}

// SetDestination sets field value
func (o *TxDestination) SetDestination(v string) {
	o.Destination = v
}

// GetAmount returns the Amount field value
func (o *TxDestination) GetAmount() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Amount
}

// GetAmountOk returns a tuple with the Amount field value
// and a boolean to check if the value has been set.
func (o *TxDestination) GetAmountOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Amount, true
}

// SetAmount sets field value
func (o *TxDestination) SetAmount(v string) {
	o.Amount = v
}

func (o TxDestination) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["destination"] = o.Destination
	}
	if true {
		toSerialize["amount"] = o.Amount
	}
	return json.Marshal(toSerialize)
}

type NullableTxDestination struct {
	value *TxDestination
	isSet bool
}

func (v NullableTxDestination) Get() *TxDestination {
	return v.value
}

func (v *NullableTxDestination) Set(val *TxDestination) {
	v.value = val
	v.isSet = true
}

func (v NullableTxDestination) IsSet() bool {
	return v.isSet
}

func (v *NullableTxDestination) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTxDestination(val *TxDestination) *NullableTxDestination {
	return &NullableTxDestination{value: val, isSet: true}
}

func (v NullableTxDestination) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTxDestination) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
